<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="名单类型" name="listType">
						<a-select v-model:value="searchFormState.listType" placeholder="请选择名单类型" :options="[{label:'白',value:'白'},{label:'黑',value:'黑'}]"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="车牌号" name="plateValue">
						<a-input v-model:value="searchFormState.plateValue" placeholder="请输入车牌号"/>
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotTruckPlateListAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<a-button danger @click="deleteBatchDepotTruckPlateList()" v-if="hasPerm('depotTruckPlateListBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'depotId'">
					{{ $TOOL.dictTypeData('depotId', record.depotId) }}
				</template>
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('depotTruckPlateListEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['depotTruckPlateListEdit', 'depotTruckPlateListDelete'], 'and')"/>
						<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotTruckPlateList(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('depotTruckPlateListDelete')">删除</a-button>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotTruckPlateList">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import depotTruckPlateListApi from '@/api/biz/depotTruckPlateListApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const depotOptions = ref([])
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '名单类型',
		dataIndex: 'listType'
	},
	{
		title: '车牌号',
		dataIndex: 'plateValue'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['depotTruckPlateListEdit', 'depotTruckPlateListDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotTruckPlateListApi.depotTruckPlateListPage(Object.assign(parameter, searchFormParam)).then((data) => {
		return data
	})
}
// 删除
const deleteDepotTruckPlateList = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotTruckPlateListApi.depotTruckPlateListDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotTruckPlateList = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotTruckPlateListApi.depotTruckPlateListDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
</script>
